searchNodes=[{"ref":"Boruta.html","title":"Boruta","type":"module","doc":"Boruta is the core of an OAuth provider giving business logic of authentication and authorization. It is intended to follow RFCs : RFC 6749 - The OAuth 2.0 Authorization Framework RFC 7662 - OAuth 2.0 Token Introspection As it, it helps implement a provider for authorization code, implicit, client credentials and resource owner password credentials grants. Then it follows Introspection to check tokens. Note : Refresh tokens are not implemented yet Installation Schemas migration Boruta need a migration for its schemas and persist both tokens and clients. This can be done by running mix boruta.gen.migration --with-accounts Configuration Boruta provides several configuration options, to customize them you can add configurations in config.exs as following config :boruta, Boruta.Oauth, repo: Boruta.Repo, expires_in: %{ access_token: 24 * 3600, authorization_code: 60 }, token_generator: Boruta.TokenGenerator, secret_key_base: System.get_env(&quot;SECRET_KEY_BASE&quot;), resource_owner: %{ schema: Boruta.Accounts.User, checkpw_method: &amp;Boruta.Accounts.HashSalt.checkpw/2 } Integration This implementation follows a pseudo hexagonal architecture to invert dependencies to Application layer. In order to expose endpoints of an OAuth server with Boruta, you need implement the behaviour Boruta.Oauth.Application with all needed callbacks for token/2, authorize/2 and introspect/2 calls from Boruta.Oauth. This library has specific interfaces to interact with Plug.Conn requests. Feedback It is a work in progress, all feedbacks / feature requests / improvments are welcome -&gt; me"},{"ref":"Boruta.Config.html","title":"Boruta.Config","type":"module","doc":"Utilities to access Boruta configuration ad set defaults. Configuration can be set as following in config.exs (this configuration is the default) config :boruta, Boruta.Oauth, repo: Boruta.Repo, expires_in: %{ access_token: 24 * 3600, authorization_code: 60 }, token_generator: Boruta.TokenGenerator, secret_key_base: System.get_env(&quot;SECRET_KEY_BASE&quot;), resource_owner: %{ schema: Boruta.Accounts.User, checkpw_method: &amp;Boruta.Accounts.HashSalt.checkpw/2 }, contexts: %{ client: Boruta.Clients, scope: Boruta.Scopes, access_token: Boruta.AccessTokens, code: Boruta.Codes, resource_owner: Boruta.ResourceOwners }"},{"ref":"Boruta.Oauth.html","title":"Boruta.Oauth","type":"module","doc":"Boruta OAuth entrypoint, handles OAuth requests. Note : this module works in association with Boruta.Oauth.Application behaviour"},{"ref":"Boruta.Oauth.html#authorize/2","title":"Boruta.Oauth.authorize/2","type":"function","doc":"Triggers authorize_success in case of success and authorize_error in case of failure from the given module. Those functions are described in Boruta.Oauth.Application behaviour. Note : resource owner must be provided as current_user assigns."},{"ref":"Boruta.Oauth.html#introspect/2","title":"Boruta.Oauth.introspect/2","type":"function","doc":"Triggers introspect_success in case of success and introspect_error in case of failure from the given module. Those functions are described in Boruta.Oauth.Application behaviour."},{"ref":"Boruta.Oauth.html#token/2","title":"Boruta.Oauth.token/2","type":"function","doc":"Triggers token_success in case of success and token_error in case of failure from the given module. Those functions are described in Boruta.Oauth.Application behaviour."},{"ref":"Boruta.Oauth.Application.html","title":"Boruta.Oauth.Application","type":"behaviour","doc":"OAuth application behaviour Implement this behaviour in the application layer of your OAuth provider. The callbacks are triggered while calling functions from Boruta.Oauth module."},{"ref":"Boruta.Oauth.Application.html#c:authorize_error/2","title":"Boruta.Oauth.Application.authorize_error/2","type":"callback","doc":"This function will be triggered in case of failure triggering Boruta.Oauth.authorize/2"},{"ref":"Boruta.Oauth.Application.html#c:authorize_success/2","title":"Boruta.Oauth.Application.authorize_success/2","type":"callback","doc":"This function will be triggered in case of success triggering Boruta.Oauth.authorize/2"},{"ref":"Boruta.Oauth.Application.html#c:introspect_error/2","title":"Boruta.Oauth.Application.introspect_error/2","type":"callback","doc":"This function will be triggered in case of failure triggering Boruta.Oauth.introspect/2"},{"ref":"Boruta.Oauth.Application.html#c:introspect_success/2","title":"Boruta.Oauth.Application.introspect_success/2","type":"callback","doc":"This function will be triggered in case of success triggering Boruta.Oauth.introspect/2"},{"ref":"Boruta.Oauth.Application.html#c:token_error/2","title":"Boruta.Oauth.Application.token_error/2","type":"callback","doc":"This function will be triggered in case of failure triggering Boruta.Oauth.token/2"},{"ref":"Boruta.Oauth.Application.html#c:token_success/2","title":"Boruta.Oauth.Application.token_success/2","type":"callback","doc":"This function will be triggered in case of success triggering Boruta.Oauth.token/2"},{"ref":"Mix.Tasks.Boruta.Gen.Migration.html","title":"Mix.Tasks.Boruta.Gen.Migration","type":"task","doc":"Migration task for Boruta. Creates clients, tokens tables. It can also create migration for boruta Accounts (users) with --with-accounts arg. Examples mix boruta.gen.migration mix boruta.gen.migration --with-accounts Command line options --with-accounts - creates Boruta Accounts (users) migration"},{"ref":"Boruta.Oauth.AuthorizeResponse.html","title":"Boruta.Oauth.AuthorizeResponse","type":"module","doc":"Authorize response"},{"ref":"Boruta.Oauth.AuthorizeResponse.html#from_token/1","title":"Boruta.Oauth.AuthorizeResponse.from_token/1","type":"function","doc":""},{"ref":"Boruta.Oauth.AuthorizeResponse.html#t:t/0","title":"Boruta.Oauth.AuthorizeResponse.t/0","type":"type","doc":""},{"ref":"Boruta.Oauth.IntrospectResponse.html","title":"Boruta.Oauth.IntrospectResponse","type":"module","doc":"Introspect response"},{"ref":"Boruta.Oauth.IntrospectResponse.html#from_error/1","title":"Boruta.Oauth.IntrospectResponse.from_error/1","type":"function","doc":""},{"ref":"Boruta.Oauth.IntrospectResponse.html#from_token/1","title":"Boruta.Oauth.IntrospectResponse.from_token/1","type":"function","doc":""},{"ref":"Boruta.Oauth.TokenResponse.html","title":"Boruta.Oauth.TokenResponse","type":"module","doc":"Token response"},{"ref":"Boruta.Oauth.TokenResponse.html#from_token/1","title":"Boruta.Oauth.TokenResponse.from_token/1","type":"function","doc":""},{"ref":"Boruta.Oauth.TokenResponse.html#t:t/0","title":"Boruta.Oauth.TokenResponse.t/0","type":"type","doc":""},{"ref":"Boruta.Oauth.Authorization.html","title":"Boruta.Oauth.Authorization","type":"protocol","doc":""},{"ref":"Boruta.Oauth.Authorization.html#token/1","title":"Boruta.Oauth.Authorization.token/1","type":"function","doc":"Creates and returns a token for given request, depending of implementation."},{"ref":"Boruta.Oauth.Authorization.html#t:t/0","title":"Boruta.Oauth.Authorization.t/0","type":"type","doc":""},{"ref":"Boruta.Oauth.Authorization.AccessToken.html","title":"Boruta.Oauth.Authorization.AccessToken","type":"module","doc":"Access token authorization"},{"ref":"Boruta.Oauth.Authorization.AccessToken.html#authorize/1","title":"Boruta.Oauth.Authorization.AccessToken.authorize/1","type":"function","doc":"Authorize the access token corresponding to the given params. Examples iex&gt; authorize(%{value: &quot;value&quot;}) {:ok, %Boruta.Oauth.Token{...}}"},{"ref":"Boruta.Oauth.Authorization.Client.html","title":"Boruta.Oauth.Authorization.Client","type":"module","doc":"Client authorization"},{"ref":"Boruta.Oauth.Authorization.Client.html#authorize/1","title":"Boruta.Oauth.Authorization.Client.authorize/1","type":"function","doc":"Authorize the client corresponding to the given params. Examples iex&gt; authorize(id: &quot;id&quot;, secret: &quot;secret&quot;) {:ok, %Boruta.Oauth.Client{...}}"},{"ref":"Boruta.Oauth.Authorization.Code.html","title":"Boruta.Oauth.Authorization.Code","type":"module","doc":"Code authorization"},{"ref":"Boruta.Oauth.Authorization.Code.html#authorize/1","title":"Boruta.Oauth.Authorization.Code.authorize/1","type":"function","doc":"Authorize the code corresponding to the given params. Examples iex&gt; authorize(value: &quot;value&quot;, redirect_uri: &quot;redirect_uri&quot;) {:ok, %Boruta.Oauth.Token{...}}"},{"ref":"Boruta.Oauth.Authorization.ResourceOwner.html","title":"Boruta.Oauth.Authorization.ResourceOwner","type":"module","doc":"Resource owner authorization"},{"ref":"Boruta.Oauth.Authorization.ResourceOwner.html#authorize/1","title":"Boruta.Oauth.Authorization.ResourceOwner.authorize/1","type":"function","doc":"Authorize the resource owner corresponding to the given params. Examples iex&gt; authorize(id: &quot;id&quot;) {:ok, %User{...}}"},{"ref":"Boruta.Oauth.Authorization.Scope.html","title":"Boruta.Oauth.Authorization.Scope","type":"module","doc":"Scope authorization"},{"ref":"Boruta.Oauth.Authorization.Scope.html#authorize/1","title":"Boruta.Oauth.Authorization.Scope.authorize/1","type":"function","doc":"Authorize the given scope according to the given client. Examples iex&gt; authorize(%{scope: &quot;scope&quot;, client: %Client{...}}) {:ok, &quot;scope&quot;}"},{"ref":"Boruta.Oauth.Introspect.html","title":"Boruta.Oauth.Introspect","type":"module","doc":"OAuth Introspect"},{"ref":"Boruta.Oauth.Introspect.html#token/1","title":"Boruta.Oauth.Introspect.token/1","type":"function","doc":"Build an introspect response for the given IntrospectRequest Note : Invalid tokens returns an error {:error, %Error{error: :invalid_access_token, ...}}. That must be rescued to return %{&quot;active&quot; =&gt; false} in application implementation. Examples iex&gt; token(%IntrospectRequest{ client_id: &quot;client_id&quot;, client_secret: &quot;client_secret&quot;, token: &quot;token&quot; }) {:ok, %Token{...}}"},{"ref":"Boruta.Oauth.AccessTokens.html","title":"Boruta.Oauth.AccessTokens","type":"behaviour","doc":"Access token context"},{"ref":"Boruta.Oauth.AccessTokens.html#c:create/2","title":"Boruta.Oauth.AccessTokens.create/2","type":"callback","doc":""},{"ref":"Boruta.Oauth.AccessTokens.html#c:get_by/1","title":"Boruta.Oauth.AccessTokens.get_by/1","type":"callback","doc":""},{"ref":"Boruta.Oauth.Clients.html","title":"Boruta.Oauth.Clients","type":"behaviour","doc":"Client context"},{"ref":"Boruta.Oauth.Clients.html#c:authorized_scopes/1","title":"Boruta.Oauth.Clients.authorized_scopes/1","type":"callback","doc":""},{"ref":"Boruta.Oauth.Clients.html#c:get_by/1","title":"Boruta.Oauth.Clients.get_by/1","type":"callback","doc":""},{"ref":"Boruta.Oauth.Codes.html","title":"Boruta.Oauth.Codes","type":"behaviour","doc":"Code context"},{"ref":"Boruta.Oauth.Codes.html#c:create/1","title":"Boruta.Oauth.Codes.create/1","type":"callback","doc":""},{"ref":"Boruta.Oauth.Codes.html#c:get_by/1","title":"Boruta.Oauth.Codes.get_by/1","type":"callback","doc":""},{"ref":"Boruta.Oauth.ResourceOwners.html","title":"Boruta.Oauth.ResourceOwners","type":"behaviour","doc":"Resource owner context"},{"ref":"Boruta.Oauth.ResourceOwners.html#c:authorized_scopes/1","title":"Boruta.Oauth.ResourceOwners.authorized_scopes/1","type":"callback","doc":""},{"ref":"Boruta.Oauth.ResourceOwners.html#c:get_by/1","title":"Boruta.Oauth.ResourceOwners.get_by/1","type":"callback","doc":""},{"ref":"Boruta.Oauth.ResourceOwners.html#c:persisted?/1","title":"Boruta.Oauth.ResourceOwners.persisted?/1","type":"callback","doc":""},{"ref":"Boruta.Oauth.Scopes.html","title":"Boruta.Oauth.Scopes","type":"behaviour","doc":"Scope context"},{"ref":"Boruta.Oauth.Scopes.html#c:public/0","title":"Boruta.Oauth.Scopes.public/0","type":"callback","doc":""},{"ref":"Boruta.Oauth.Client.html","title":"Boruta.Oauth.Client","type":"module","doc":"OAuth client schema"},{"ref":"Boruta.Oauth.Client.html#t:t/0","title":"Boruta.Oauth.Client.t/0","type":"type","doc":""},{"ref":"Boruta.Oauth.Scope.html","title":"Boruta.Oauth.Scope","type":"module","doc":"Schema defining an independent OAuth scope"},{"ref":"Boruta.Oauth.Scope.html#split/1","title":"Boruta.Oauth.Scope.split/1","type":"function","doc":"Splits an OAuth scope string into individual scopes as string Examples iex&gt; scope(&quot;a:scope another:scope&quot;) [&quot;a:scope&quot;, &quot;another:scope&quot;]"},{"ref":"Boruta.Oauth.Scope.html#t:t/0","title":"Boruta.Oauth.Scope.t/0","type":"type","doc":""},{"ref":"Boruta.Oauth.Token.html","title":"Boruta.Oauth.Token","type":"module","doc":"Token schema. Representing both access tokens and codes."},{"ref":"Boruta.Oauth.Token.html#expired?/1","title":"Boruta.Oauth.Token.expired?/1","type":"function","doc":"Determines if a token is expired Examples iex&gt; expired?(%Boruta.Oauth.Token{expires_at: 1638316800}) # 1st january 2021 :ok iex&gt; expired?(%Boruta.Oauth.Token{expires_at: 0}) # 1st january 1970 {:error, &quot;Token expired.&quot;}"},{"ref":"Boruta.Oauth.Token.html#t:t/0","title":"Boruta.Oauth.Token.t/0","type":"type","doc":""},{"ref":"Boruta.Oauth.AuthorizationCodeRequest.html","title":"Boruta.Oauth.AuthorizationCodeRequest","type":"module","doc":"Authorization code request"},{"ref":"Boruta.Oauth.AuthorizationCodeRequest.html#t:t/0","title":"Boruta.Oauth.AuthorizationCodeRequest.t/0","type":"type","doc":"Type representing an authorization code request as stated in OAuth 2.0 RFC."},{"ref":"Boruta.Oauth.ClientCredentialsRequest.html","title":"Boruta.Oauth.ClientCredentialsRequest","type":"module","doc":"Client credentials request"},{"ref":"Boruta.Oauth.ClientCredentialsRequest.html#t:t/0","title":"Boruta.Oauth.ClientCredentialsRequest.t/0","type":"type","doc":"Type representing a client credentials request as stated in OAuth 2.0 RFC."},{"ref":"Boruta.Oauth.CodeRequest.html","title":"Boruta.Oauth.CodeRequest","type":"module","doc":"Code request"},{"ref":"Boruta.Oauth.CodeRequest.html#t:t/0","title":"Boruta.Oauth.CodeRequest.t/0","type":"type","doc":"Type representing a code request as stated in OAuth 2.0 RFC. Note : resource_owner is an addition that must be provided by the application layer."},{"ref":"Boruta.Oauth.IntrospectRequest.html","title":"Boruta.Oauth.IntrospectRequest","type":"module","doc":"Introspect request"},{"ref":"Boruta.Oauth.IntrospectRequest.html#t:t/0","title":"Boruta.Oauth.IntrospectRequest.t/0","type":"type","doc":"Type representing an introspect request as stated in Introspect RFC."},{"ref":"Boruta.Oauth.PasswordRequest.html","title":"Boruta.Oauth.PasswordRequest","type":"module","doc":"Resource owner password credentials request"},{"ref":"Boruta.Oauth.PasswordRequest.html#t:t/0","title":"Boruta.Oauth.PasswordRequest.t/0","type":"type","doc":"Type representing a resource owner password credentials request as stated in OAuth 2.0 RFC."},{"ref":"Boruta.Oauth.RefreshTokenRequest.html","title":"Boruta.Oauth.RefreshTokenRequest","type":"module","doc":"Refresh token request"},{"ref":"Boruta.Oauth.RefreshTokenRequest.html#t:t/0","title":"Boruta.Oauth.RefreshTokenRequest.t/0","type":"type","doc":"Type representing a refresh token request as stated in OAuth 2.0 RFC."},{"ref":"Boruta.Oauth.Request.html","title":"Boruta.Oauth.Request","type":"module","doc":"Build a business structs from given input. Note : Input must have the shape or be a %Plug.Conn{} request."},{"ref":"Boruta.Oauth.Request.html#authorize_request/1","title":"Boruta.Oauth.Request.authorize_request/1","type":"function","doc":"Create business struct from an OAuth authorize request. Note : resource owner must be provided as current_user assigns. Examples iex&gt;authorize_request(%{ query_params: %{ &quot;response_type&quot; =&gt; &quot;token&quot;, &quot;client_id&quot; =&gt; &quot;client_id&quot;, &quot;redirect_uri&quot; =&gt; &quot;redirect_uri&quot; }, assigns: %{current_user: %User{...}} }) {:ok, %TokenRequest{...}}"},{"ref":"Boruta.Oauth.Request.html#introspect_request/1","title":"Boruta.Oauth.Request.introspect_request/1","type":"function","doc":"Create business struct from an OAuth introspect request. Examples iex&gt;introspect_request(%{ body_params: %{ &quot;token&quot; =&gt; &quot;token&quot;, &quot;client_id&quot; =&gt; &quot;client_id&quot;, &quot;client_secret&quot; =&gt; &quot;client_secret&quot;, } }) {:ok, %IntrospectRequest{...}}"},{"ref":"Boruta.Oauth.Request.html#token_request/1","title":"Boruta.Oauth.Request.token_request/1","type":"function","doc":"Create business struct from an OAuth token request. Examples iex&gt;token_request(%{ body_params: %{ &quot;grant_type&quot; =&gt; &quot;client_credentials&quot;, &quot;client_id&quot; =&gt; &quot;client_id&quot;, &quot;client_secret&quot; =&gt; &quot;client_secret&quot; } }) {:ok, %ClientCredentialsRequest{...}}"},{"ref":"Boruta.Oauth.TokenRequest.html","title":"Boruta.Oauth.TokenRequest","type":"module","doc":"Implicit request"},{"ref":"Boruta.Oauth.TokenRequest.html#t:t/0","title":"Boruta.Oauth.TokenRequest.t/0","type":"type","doc":"Type representing an implicit request as stated in OAuth 2.0 RFC. Note : resource_owner is an addition that must be provided by the application layer."},{"ref":"Boruta.Admin.html","title":"Boruta.Admin","type":"module","doc":"The Admin context."},{"ref":"Boruta.Admin.html#create_client/1","title":"Boruta.Admin.create_client/1","type":"function","doc":"See Boruta.Admin.Clients.create_client/1."},{"ref":"Boruta.Admin.html#create_scope/1","title":"Boruta.Admin.create_scope/1","type":"function","doc":"See Boruta.Admin.Scopes.create_scope/1."},{"ref":"Boruta.Admin.html#delete_client/1","title":"Boruta.Admin.delete_client/1","type":"function","doc":"See Boruta.Admin.Clients.delete_client/1."},{"ref":"Boruta.Admin.html#delete_scope/1","title":"Boruta.Admin.delete_scope/1","type":"function","doc":"See Boruta.Admin.Scopes.delete_scope/1."},{"ref":"Boruta.Admin.html#delete_user/1","title":"Boruta.Admin.delete_user/1","type":"function","doc":"See Boruta.Admin.Users.delete_user/1."},{"ref":"Boruta.Admin.html#get_client!/1","title":"Boruta.Admin.get_client!/1","type":"function","doc":"See Boruta.Admin.Clients.get_client!/1."},{"ref":"Boruta.Admin.html#get_scope!/1","title":"Boruta.Admin.get_scope!/1","type":"function","doc":"See Boruta.Admin.Scopes.get_scope!/1."},{"ref":"Boruta.Admin.html#get_user!/1","title":"Boruta.Admin.get_user!/1","type":"function","doc":"See Boruta.Admin.Users.get_user!/1."},{"ref":"Boruta.Admin.html#list_clients/0","title":"Boruta.Admin.list_clients/0","type":"function","doc":"See Boruta.Admin.Clients.list_clients/0."},{"ref":"Boruta.Admin.html#list_scopes/0","title":"Boruta.Admin.list_scopes/0","type":"function","doc":"See Boruta.Admin.Scopes.list_scopes/0."},{"ref":"Boruta.Admin.html#list_users/0","title":"Boruta.Admin.list_users/0","type":"function","doc":"See Boruta.Admin.Users.list_users/0."},{"ref":"Boruta.Admin.html#update_client/2","title":"Boruta.Admin.update_client/2","type":"function","doc":"See Boruta.Admin.Clients.update_client/2."},{"ref":"Boruta.Admin.html#update_scope/2","title":"Boruta.Admin.update_scope/2","type":"function","doc":"See Boruta.Admin.Scopes.update_scope/2."},{"ref":"Boruta.Admin.html#update_user/2","title":"Boruta.Admin.update_user/2","type":"function","doc":"See Boruta.Admin.Users.update_user/2."},{"ref":"Boruta.Admin.Clients.html","title":"Boruta.Admin.Clients","type":"module","doc":"TODO Admin Clients documentation"},{"ref":"Boruta.Admin.Clients.html#create_client/1","title":"Boruta.Admin.Clients.create_client/1","type":"function","doc":"Creates a client. Examples iex&gt; create_client(%{field: value}) {:ok, %Client{}} iex&gt; create_client(%{field: bad_value}) {:error, %Ecto.Changeset{}}"},{"ref":"Boruta.Admin.Clients.html#delete_client/1","title":"Boruta.Admin.Clients.delete_client/1","type":"function","doc":"Deletes a Client. Examples iex&gt; delete_client(client) {:ok, %Client{}} iex&gt; delete_client(client) {:error, %Ecto.Changeset{}}"},{"ref":"Boruta.Admin.Clients.html#get_client!/1","title":"Boruta.Admin.Clients.get_client!/1","type":"function","doc":"Gets a single client. Raises Ecto.NoResultsError if the Client does not exist. Examples iex&gt; get_client!(123) %Client{} iex&gt; get_client!(456) ** (Ecto.NoResultsError)"},{"ref":"Boruta.Admin.Clients.html#list_clients/0","title":"Boruta.Admin.Clients.list_clients/0","type":"function","doc":"Returns the list of clients. Examples iex&gt; list_clients() [%Client{}, ...]"},{"ref":"Boruta.Admin.Clients.html#update_client/2","title":"Boruta.Admin.Clients.update_client/2","type":"function","doc":"Updates a client. Examples iex&gt; update_client(client, %{field: new_value}) {:ok, %Client{}} iex&gt; update_client(client, %{field: bad_value}) {:error, %Ecto.Changeset{}}"},{"ref":"Boruta.Admin.Scopes.html","title":"Boruta.Admin.Scopes","type":"module","doc":"TODO Admin Scopes documentation"},{"ref":"Boruta.Admin.Scopes.html#create_scope/1","title":"Boruta.Admin.Scopes.create_scope/1","type":"function","doc":"Creates a scope. Examples iex&gt; create_scope(%{field: value}) {:ok, %Scope{}} iex&gt; create_scope(%{field: bad_value}) {:error, %Ecto.Changeset{}}"},{"ref":"Boruta.Admin.Scopes.html#delete_scope/1","title":"Boruta.Admin.Scopes.delete_scope/1","type":"function","doc":"Deletes a Scope. Examples iex&gt; delete_scope(scope) {:ok, %Scope{}} iex&gt; delete_scope(scope) {:error, %Ecto.Changeset{}}"},{"ref":"Boruta.Admin.Scopes.html#get_scope!/1","title":"Boruta.Admin.Scopes.get_scope!/1","type":"function","doc":"Gets a single scope. Raises Ecto.NoResultsError if the Scope does not exist. Examples iex&gt; get_scope!(123) %Scope{} iex&gt; get_scope!(456) ** (Ecto.NoResultsError)"},{"ref":"Boruta.Admin.Scopes.html#list_scopes/0","title":"Boruta.Admin.Scopes.list_scopes/0","type":"function","doc":"Returns the list of scopes. Examples iex&gt; list_scopes() [%Scope{}, ...]"},{"ref":"Boruta.Admin.Scopes.html#update_scope/2","title":"Boruta.Admin.Scopes.update_scope/2","type":"function","doc":"Updates a scope. Examples iex&gt; update_scope(scope, %{field: new_value}) {:ok, %Scope{}} iex&gt; update_scope(scope, %{field: bad_value}) {:error, %Ecto.Changeset{}}"},{"ref":"Boruta.Admin.Users.html","title":"Boruta.Admin.Users","type":"module","doc":"TODO Admin Users documentation"},{"ref":"Boruta.Admin.Users.html#delete_user/1","title":"Boruta.Admin.Users.delete_user/1","type":"function","doc":"Deletes a User. Examples iex&gt; delete_user(user) {:ok, %User{}} iex&gt; delete_user(user) {:error, %Ecto.Changeset{}}"},{"ref":"Boruta.Admin.Users.html#get_user!/1","title":"Boruta.Admin.Users.get_user!/1","type":"function","doc":"Gets a single user. Raises Ecto.NoResultsError if the User does not exist. Examples iex&gt; get_user!(123) %User{} iex&gt; get_user!(456) ** (Ecto.NoResultsError)"},{"ref":"Boruta.Admin.Users.html#list_users/0","title":"Boruta.Admin.Users.list_users/0","type":"function","doc":"Returns the list of users. Examples iex&gt; list_users() [%User{}, ...]"},{"ref":"Boruta.Admin.Users.html#update_user/2","title":"Boruta.Admin.Users.update_user/2","type":"function","doc":"Updates an user. Examples iex&gt; update_user(user, %{field: new_value}) {:ok, %User{}} iex&gt; update_user(user, %{field: bad_value}) {:error, %Ecto.Changeset{}}"},{"ref":"Boruta.BasicAuth.html","title":"Boruta.BasicAuth","type":"module","doc":"HTTP BasicAuth utilities Provide utilities to decode Basic authorization header as stated in RFC 7617 - The &#39;Basic&#39; HTTP Authentication Scheme"},{"ref":"Boruta.BasicAuth.html#decode/1","title":"Boruta.BasicAuth.decode/1","type":"function","doc":"Decode given authorization header and returns an array containing username and password. Examples iex&gt; Boruta.BasicAuth.decode(&quot;Basic dXNlcm5hbWU6cGFzc3dvcmQ=&quot;) {:ok, [&quot;username&quot;, &quot;password&quot;]} iex&gt; Boruta.BasicAuth.decode(&quot;bad_authorization_header&quot;) {:error, &quot;`bad_authorization_header` is not a valid Basic authorization header.&quot;}"},{"ref":"Boruta.Oauth.TokenGenerator.html","title":"Boruta.Oauth.TokenGenerator","type":"behaviour","doc":"Behaviour to implement utilities to generate token value. This must be implemented in the module configured as token_generator set in config.exs"},{"ref":"Boruta.Oauth.TokenGenerator.html#c:generate/2","title":"Boruta.Oauth.TokenGenerator.generate/2","type":"callback","doc":"Generates a token value from token entity."},{"ref":"Boruta.Oauth.TokenGenerator.html#c:secret/1","title":"Boruta.Oauth.TokenGenerator.secret/1","type":"callback","doc":"Generates a secret from client entity."},{"ref":"Boruta.Oauth.Validator.html","title":"Boruta.Oauth.Validator","type":"module","doc":"Utility to validate the request according to the given parameters."},{"ref":"Boruta.Oauth.Validator.html#validate/2","title":"Boruta.Oauth.Validator.validate/2","type":"function","doc":"Validates given OAuth parameters. Examples iex&gt; validate(%{ &quot;grant_type&quot; =&gt; &quot;client_credentials&quot;, &quot;client_id&quot; =&gt; &quot;client_id&quot;, &quot;client_secret&quot; =&gt; &quot;client_secret&quot; }) {:ok, %{ &quot;grant_type&quot; =&gt; &quot;client_credentials&quot;, &quot;client_id&quot; =&gt; &quot;client_id&quot;, &quot;client_secret&quot; =&gt; &quot;client_secret&quot; }} iex&gt; validate(%{}) {:error, &quot;Request is not a valid OAuth request. Need a grant_type or a response_type param.&quot;}"},{"ref":"Boruta.Oauth.Error.html","title":"Boruta.Oauth.Error","type":"module","doc":"Boruta OAuth errors Intended to follow OAuth 2.0 errors. Additionnal errors are provided as purpose."},{"ref":"Boruta.Oauth.Error.html#with_format/2","title":"Boruta.Oauth.Error.with_format/2","type":"function","doc":""},{"ref":"Boruta.Oauth.Error.html#t:t/0","title":"Boruta.Oauth.Error.t/0","type":"type","doc":""}]